#include <stdio.h>
#include <X11/X.h>
#include "scope.h"
#include "x11.h"
static char *Leader = "\t";
extern void PrintText();
extern int  littleEndian;

/* ************************************************************ */
/*								*/
/*								*/
/* ************************************************************ */

#define MAXline 78

static
DumpHexBuffer(buf, n)
     unsigned char *buf;
     long    n;
{
  short   i;
  short   column;
  char    h[6] /* one hex or octal character */ ;

  column = 16;
  for (i = 0; i < n; i++)
    {
      /* get the hex representations */
      (void)sprintf(h, "%02x",(0xff & buf[i]));

      /* check if these characters will fit on this line */
      if ((column + strlen(h) + 1) > MAXline)
	{
	  /* line will be too long -- print it */
	  fprintf(stdout, "\n");
	  column = 0;
	}
      fprintf(stdout, "%s ", h);
      column += 3;
    }
}

DumpGLX(name, fd, buf, n)
     char   *name;
     FD      fd;
     unsigned char *buf;
     long    n;
{
  int op;

  if (n == 0)
    return;


  op = buf[1];

/* Process GLX command */

    glSingle(fd,buf,n);
    return;
}


gl_decode_req(name, fd, buf, n)
     char   *name;
     FD      fd;
     unsigned char *buf;
     long    n;
{
  int op;

  if (n == 0)
    return;


  op = buf[1];

/* Process GLX command */

  glSingle(fd,buf,n);
  return;
}

GLXRender(buf,n)
unsigned char *buf;
int n;
{
  buf += 8;
  n -= 8;

  while (n > 0) {
    int len = IShort (buf);
    int op = IShort(buf+2);

    if (Verbose > 3) {
    	DumpHexBuffer(buf, len);
    	fprintf(stdout, "\n");
    }
    decode_glRender(buf,len,op);
    buf += len;
    n -= len;
  }
}


void
PrintText(s)
char *s;
{
  fprintf(stdout, " %s ", s);
}

PrintFLOAT32(buf)
char buf[];
{
    union {
	float f;
	long  l;
	char  c[4];
    } u;
    u.l = ILong(buf);
    fprintf(stdout,"%g", u.f);
    return 4;
}

PrintFLOAT64(buf)
char buf[];
{
    union {
	double d;
	char  c[8];
    } u;
  /* check for byte-swapping */
    if (littleEndian) {
	u.c[0]=buf[7];
	u.c[1]=buf[6];
	u.c[2]=buf[5];
	u.c[3]=buf[4];
	u.c[4]=buf[3];
	u.c[5]=buf[2];
	u.c[6]=buf[1];
	u.c[7]=buf[0];
    } else
	memcpy(u.c, buf, 8);
    fprintf(stdout,"%g", u.d);
    return 8;
}

void
PrintINT32array(buf,n)
char *buf;
int n;
{
    if (Verbose > 2)
    	printf("(%d bytes)", n);
    n = n/4;
    while(n > 0) {
	printf(n%4 ? "\t" : "\n\t\t");
	PrintINT32(buf);
	buf += 4;
	n--;
    }
}


void
PrintFLOAT32array(buf,n)
char *buf;
int n;
{
    if (Verbose > 2)
    	printf("(%d bytes)", n);
    n = n/4;
    while(n > 0) {
	printf(n%4 ? "\t" : "\n\t\t");
	PrintFLOAT32(buf);
	buf += 4;
	n--;
    }
}


void
PrintFLOAT64array(buf,n)
char *buf;
int n;
{
    if (Verbose > 2)
    	printf("(%d bytes)", n);
    n = n/8;
    while(n > 0) {
	printf(n%4 ? "\t" : "\n\t\t");
	PrintFLOAT64(buf);
	buf += 8;
	n--;
    }
}


void
PrintCHARarray(buf,n)
char *buf;
int n;
{
    if (Verbose > 2)
    	printf("(%d bytes)", n);
    while(n > 0) {
	printf(n%64 ? " " : "\n\t\t");
	PrintCHAR8(buf);
	buf += 8;
	n--;
    }
}


void
PrintSHORTarray(buf,n)
char *buf;
int n;
{
    if (Verbose > 2)
    	printf("(%d bytes)", n);
    while(n > 0) {
	printf(n%16 ? "\t" : "\n\t\t");
	PrintINT16(buf);
	buf += 8;
	n--;
    }
}

void
GLXReplyExpected(fd, Request)
FD fd;
int Request;
{
	ReplyExpected(fd, 1000+Request);
}

PrintGLX_PIXEL_HDR(buf)
unsigned char *buf;
{
  PrintText("swap_bytes"); PrintBOOL(buf + 4);
  PrintText("lsb_first"); PrintBOOL(buf + 5);
  PrintText("row_length"); PrintCARD32(buf + 9);
  PrintText("skip_rows"); PrintCARD32(buf + 12);
  PrintText("skip_pixels"); PrintCARD32(buf + 16);
  PrintText("alignment"); PrintCARD32(buf + 20);
/*  fprintf(stdout, "\n");*/
}

PrintBOOL(buf)
unsigned char *buf;
{
  fprintf(stdout, "%s", buf[1] ? "True" : "False");
}

PrintGLENUM(buf)
     unsigned char *buf;
{
  /* print a GLENUM -- GL enumerated type */
  PrintENUMERATED(buf, 4, TD[GLENUM].ValueList);
  return 4;
}

PrintglBeginMode(buf)
     unsigned char *buf;
{
  /* print a GLENUM -- GL enumerated type */
  PrintENUMERATED(buf, 4, TD[glBeginMode].ValueList);
  return 4;
}

PrintBITFIELD(buf)
     unsigned char *buf;
{
  /* print a BITFIELD -- GL bitfield type */
  PrintSET(buf, 4, TD[BITFIELD].ValueList);
  return 4;
}
